import requests
import json
import gkeepapi


##########################################################################################
# FONCTION POUR RECUPERER LE CODE BARRE
##########################################################################################
def barcode_reader():
	code = ""
	done = False

	fp = open('/dev/hidraw0', 'rb')
	while not done:
			buffer = fp.read(8)
			for c in buffer:
				if ord(c) > 0:
					e = (ord(c)) + 19   # pour une raison inconnue, il y a un decallage de 19. 
					if e == 58:			# pour le 0, le scanner envoie 58. Il ne suit pas l'ASCII. Donc je le passe en 48
						e = 48
					if e != 59:			
						code = code + chr(e)
					if e == 59:
						done = True
	return code

##########################################################################################
# FONCTION POUR RECUPERER LE NOM SUR OPENFOODFACTS EN JSON
##########################################################################################

def off(off_result):

	url = 'https://world.openfoodfacts.org/api/v0/product/' + off_result + '.json'
	# Open Food Facts demande un headers avec quelques infos. Histoire de savoir a qui ils ont a faire
	headers = {'user-agent': 'Bull-Eye Scanner - Raspberry Pi - Version 1.0 - https://monsiteweb.com'}
	page = requests.get(url, headers = headers)
	data_url = (json.dumps(page.json(), indent=2, sort_keys=True))
	data_page = json.loads(data_url)
	if  (data_page['status']) == 1:
		name = (data_page['product']['product_name_fr'])
		
		return name
	else:
		name = 0
		return name
	
##########################################################################################
##########################################################################################
##########################################################################################



##########################################################################################
# FONCTION POUR ENVOYER LE RESULTAT SUR GOOGLE KEEP
##########################################################################################

def upload_keep(upload_keep_product_name, upload_keep_note):

	# Enregistrement du nom du produit dans la liste GooglKeep
	gnote = keep.get(upload_keep_note)
	list = gnote.text # Recuperation des elements de la note pour voir s'ils sont deja present. Si c'est le cas, on ne l'ajoute pas
	found = list.find(upload_keep_product_name)
	if found == -1:
		gnote.add(upload_keep_product_name, False, gkeepapi.node.NewListItemPlacementValue.Top)
		keep.sync()
	
	
##########################################################################################
##########################################################################################
##########################################################################################



##########################################################################################
# CODE FINAL
##########################################################################################

# Activation de l'API Google Keep
keep = gkeepapi.Keep()
username = 'moncomptegoogle@gmail.com'
token = 'lkqjdsflkjfsqLKQSJFLKZEI98739485+='

# Connexion au compte Google Keep
keep.resume(username, token)

# Boucle pour la recherche du nom du produit
while True:  
	barcode = barcode_reader()
	print (barcode)
	off_product_name = off(barcode)
	keep.sync(resync=True)
	
	if off_product_name == 0:
		print ("Le produit n'a pas ete trouve")
		upload_keep(barcode, '1uK-TX3sUyHsvgU8CZYG74GP8cDL7z_ZdMHJYKCCebxt8Vy6LmMKLR_Z8SUe9yw')
	else:
		upload_keep(off_product_name, '1zSqXmEm0Z93XLf4xW3VaiK_ZiOCZIswPU6DlNhescwKa1WgPsHp8xTpX7RMvcfxUJND2')

